/*--------------------------------------------------------------------------+

$Id$
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable;

import static org.fortiss.af3.generator.common.utils.SourceModelElementFactory.createStaticContentSourceUnit;

import org.eclipse.emf.common.util.EList;
import org.fortiss.af3.generator.common.model.source.SourcePackage;
import org.fortiss.af3.platform.language.executable.GenericPlatformUnitExecutableBase;
import org.fortiss.af3.platform.model.PlatformArchitecture;
import org.fortiss.af3.platform.model.PlatformConnectorUnit;
import org.fortiss.af3.platform.raspberry.generated.files.RaspberryFileGeneration;
import org.fortiss.af3.platform.raspberry.model.RaspberryPi2;

/**
 * 
 * @author chaudhary
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash:
 */
public class RaspberryPi2Executable extends GenericPlatformUnitExecutableBase<RaspberryPi2> {

	/**
	 * @param modelElement
	 */
	public RaspberryPi2Executable(RaspberryPi2 modelElement) {
		super(modelElement);
		// TODO Auto-generated constructor stub
		PlatformArchitecture platformArchitecture = modelElement.getPlatformArchitecture();
		platformArchitecture.getConnectors();
	}

	/** Create files for Sensors and Actuators. */
	public void createPeripheralsInfo(SourcePackage pack) {
		EList<PlatformConnectorUnit> conns = modelElement.getPlatformConnectorUnits();

		String sensorList = "{\n";

		for(PlatformConnectorUnit exec : conns) {
			// ExecutableBase<? extends PlatformConnectorUnit> exec =
			// getPlatformArchitectureExecutable().getExecutable((PlatformConnectorUnit)p);

			if(exec instanceof SensorExecutable) {
				String details = ((SensorInExecutable)exec).getSensorDetails();
				sensorList += details;
			}
		}
		sensorList += "\n}";
		RaspberryFileGeneration sensorsInfoGen = new RaspberryFileGeneration(sensorList);
		sensorsInfoGen.createInfofile();
		pack.addUnit(createStaticContentSourceUnit("sensors.c", sensorsInfoGen.getContent(), false));
	}

}
